diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/multi-link-element.h ns-3.39/src/wifi/model/eht/multi-link-element.h
--- ns-3.38/src/wifi/model/eht/multi-link-element.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/multi-link-element.h	2023-07-05 14:23:48.109428400 -0700
@@ -118,6 +118,28 @@
      * \return the number of bytes read
      */
     uint8_t Deserialize(Buffer::Iterator start, uint16_t presence);
+
+    /**
+     * \param delay the EMLSR Padding delay
+     * \return the encoded value for the EMLSR Padding Delay subfield
+     */
+    static uint8_t EncodeEmlsrPaddingDelay(Time delay);
+    /**
+     * \param value the value for the EMLSR Padding Delay subfield
+     * \return the corresponding EMLSR Padding delay
+     */
+    static Time DecodeEmlsrPaddingDelay(uint8_t value);
+
+    /**
+     * \param delay the EMLSR Transition delay
+     * \return the encoded value for the EMLSR Transition Delay subfield
+     */
+    static uint8_t EncodeEmlsrTransitionDelay(Time delay);
+    /**
+     * \param value the value for the EMLSR Transition Delay subfield
+     * \return the corresponding EMLSR Transition delay
+     */
+    static Time DecodeEmlsrTransitionDelay(uint8_t value);
 };
 
 /**
@@ -162,19 +184,25 @@
         PER_STA_PROFILE_SUBELEMENT_ID = 0
     };
 
+    /// Typedef for structure holding a reference to the containing frame
+    using ContainingFrame = std::variant<std::monostate,
+                                         std::reference_wrapper<const MgtAssocRequestHeader>,
+                                         std::reference_wrapper<const MgtReassocRequestHeader>,
+                                         std::reference_wrapper<const MgtAssocResponseHeader>>;
+
     /**
      * Construct a Multi-Link Element with no variant set.
      *
-     * \param frameType the type of the frame containing the Multi-Link Element
+     * \param frame the management frame containing this Multi-Link Element
      */
-    MultiLinkElement(WifiMacType frameType);
+    MultiLinkElement(ContainingFrame frame = {});
     /**
      * Constructor
      *
      * \param variant the Multi-Link element variant (cannot be UNSET)
-     * \param frameType the type of the frame containing the Multi-Link Element
+     * \param frame the management frame containing this Multi-Link Element
      */
-    MultiLinkElement(Variant variant, WifiMacType frameType);
+    MultiLinkElement(Variant variant, ContainingFrame frame = {});
 
     WifiInformationElementId ElementId() const override;
     WifiInformationElementId ElementIdExt() const override;
@@ -310,6 +338,77 @@
     uint8_t GetMediumSyncMaxNTxops() const;
 
     /**
+     * Set the EMLSR Support subfield of the EML Capabilities subfield in the Common Info field
+     * to 1 if EMLSR mode is supported and set it to 0 otherwise. Make sure that this is a Basic
+     * Multi-Link Element.
+     *
+     * \param supported whether EMLSR mode is supported
+     */
+    void SetEmlsrSupported(bool supported);
+    /**
+     * Set the EMLSR Padding Delay subfield of the EML Capabilities subfield in the
+     * Common Info field. Make sure that this is a Basic Multi-Link Element.
+     *
+     * \param delay the EMLSR Padding delay (0us, 32us, 64us, 128us or 256us)
+     */
+    void SetEmlsrPaddingDelay(Time delay);
+    /**
+     * Set the EMLSR Transition Delay subfield of the EML Capabilities subfield in the
+     * Common Info field. Make sure that this is a Basic Multi-Link Element.
+     *
+     * \param delay the EMLSR Transition delay (0us, 16us, 32us, 64us, 128us or 256us)
+     */
+    void SetEmlsrTransitionDelay(Time delay);
+    /**
+     * Set the Transition Timeout subfield of the EML Capabilities subfield in the
+     * Common Info field. Make sure that this is a Basic Multi-Link Element.
+     *
+     * \param timeout the Transition Timeout (0us or 2^n us, with n=7..16)
+     */
+    void SetTransitionTimeout(Time timeout);
+    /**
+     * Return true if the EML Capabilities subfield in the Common Info field is present
+     * and false otherwise. Make sure that this is a Basic Multi-Link Element.
+     *
+     * \return whether the EML Capabilities subfield in the Common Info field is present
+     */
+    bool HasEmlCapabilities() const;
+    /**
+     * Return true if the EMLSR Support subfield of the EML Capabilities subfield in the
+     * Common Info field is set to 1 and false otherwise. Make sure that this is a Basic
+     * Multi-Link Element and the EML Capabilities subfield is present.
+     *
+     * \return whether the EMLSR Support subfield is set to 1
+     */
+    bool IsEmlsrSupported() const;
+    /**
+     * Get the EMLSR Padding Delay subfield of the EML Capabilities subfield in the
+     * Common Info field. Make sure that this is a Basic Multi-Link Element and the
+     * EML Capabilities subfield is present.
+     *
+     * \return the EMLSR Padding Delay
+     */
+    Time GetEmlsrPaddingDelay() const;
+    /**
+     * Get the EMLSR Transition Delay subfield of the EML Capabilities subfield in the
+     * Common Info field. Make sure that this is a Basic Multi-Link Element and the
+     * EML Capabilities subfield is present.
+     *
+     * \return the EMLSR Transition Delay
+     */
+    Time GetEmlsrTransitionDelay() const;
+    /**
+     * Get the Transition Timeout subfield of the EML Capabilities subfield in the
+     * Common Info field. Make sure that this is a Basic Multi-Link Element and the
+     * EML Capabilities subfield is present.
+     *
+     * \return the Transition Timeout
+     */
+    Time GetTransitionTimeout() const;
+
+    mutable ContainingFrame m_containingFrame; //!< reference to the mgt frame containing this MLE
+
+    /**
      * \ingroup wifi
      * Per-STA Profile Subelement of Multi-Link element.
      * See Sec. 9.4.2.312.2.3 of 802.11be D1.5
@@ -328,9 +427,8 @@
          * Constructor
          *
          * \param variant the Multi-Link element variant
-         * \param frameType the type of the frame containing the Multi-Link Element
          */
-        PerStaProfileSubelement(Variant variant, WifiMacType frameType);
+        PerStaProfileSubelement(Variant variant);
 
         /**
          * Copy constructor performing a deep copy of the object
@@ -460,18 +558,23 @@
          */
         uint8_t GetStaInfoLength() const;
 
+        mutable ContainingFrame
+            m_containingFrame; //!< the mgt frame containing this Per-STA Profile
+
       private:
         uint16_t GetInformationFieldSize() const override;
         void SerializeInformationField(Buffer::Iterator start) const override;
         uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
 
         Variant m_variant;            //!< Multi-Link element variant
-        WifiMacType m_frameType;      //!< type of the frame containing the Multi-Link Element
         uint16_t m_staControl;        //!< STA Control field
         Mac48Address m_staMacAddress; //!< STA MAC address
-        std::unique_ptr<Header> m_staProfile; /**< STA Profile field, containing the frame body of a
-                                                   frame of the same type as the frame containing
-                                                 the Multi-Link Element */
+        std::variant<std::monostate,
+                     std::unique_ptr<MgtAssocRequestHeader>,
+                     std::unique_ptr<MgtReassocRequestHeader>,
+                     std::unique_ptr<MgtAssocResponseHeader>>
+            m_staProfile; /**< STA Profile field, containing the frame body of a frame of the
+                               same type as the frame containing the Multi-Link Element */
     };
 
     /**
@@ -507,8 +610,6 @@
      */
     void SetVariant(Variant variant);
 
-    WifiMacType m_frameType; //!< type of the frame containing the Multi-Link Element
-
     /// Typedef for structure holding a Common Info field
     using CommonInfo = std::variant<CommonInfoBasicMle,
                                     // TODO Add other variants
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/extended-capabilities.cc ns-3.39/src/wifi/model/extended-capabilities.cc
--- ns-3.38/src/wifi/model/extended-capabilities.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/extended-capabilities.cc	2023-07-05 14:23:48.109428400 -0700
@@ -92,6 +92,12 @@
 }
 
 void
+ExtendedCapabilities::Print(std::ostream& os) const
+{
+    os << "Extended Capabilities=" << +GetExtendedCapabilitiesByte1();
+}
+
+void
 ExtendedCapabilities::SetHtSupported(uint8_t htSupported)
 {
     m_htSupported = htSupported;
@@ -373,11 +379,4 @@
     return length;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const ExtendedCapabilities& extendedCapabilities)
-{
-    os << +extendedCapabilities.GetExtendedCapabilitiesByte1();
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/extended-capabilities.h ns-3.39/src/wifi/model/extended-capabilities.h
--- ns-3.38/src/wifi/model/extended-capabilities.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/extended-capabilities.h	2023-07-05 14:23:48.109428400 -0700
@@ -41,6 +41,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
     /**
      * Set the HT Supported flag.
      *
@@ -226,16 +227,6 @@
                             ///< element should be added to the frame or not
 };
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param extendedCapabilities the extended capabilities
- *
- * \returns output stream
- */
-std::ostream& operator<<(std::ostream& os, const ExtendedCapabilities& extendedCapabilities);
-
 } // namespace ns3
 
 #endif /* EXTENDED_CAPABILITIES_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/fcfs-wifi-queue-scheduler.cc ns-3.39/src/wifi/model/fcfs-wifi-queue-scheduler.cc
--- ns-3.38/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2023-07-05 14:23:48.109428400 -0700
@@ -132,15 +132,11 @@
 
     const auto queueId = WifiMacQueueContainer::GetQueueId(mpdu);
 
-    if (GetWifiMacQueue(ac)->GetNPackets(queueId) > 1)
-    {
-        // Enqueue takes place at the tail, while the priority is determined by the
-        // head of the queue. Therefore, if the queue was not empty before inserting
-        // this MPDU, priority does not change
-        return;
-    }
+    // priority is determined by the head of the queue
+    auto item = GetWifiMacQueue(ac)->PeekByQueueId(queueId);
+    NS_ASSERT(item);
 
-    SetPriority(ac, queueId, {mpdu->GetExpiryTime(), std::get<WifiContainerQueueType>(queueId)});
+    SetPriority(ac, queueId, {item->GetTimestamp(), std::get<WifiContainerQueueType>(queueId)});
 }
 
 void
@@ -161,7 +157,7 @@
         {
             SetPriority(ac,
                         queueId,
-                        {item->GetExpiryTime(), std::get<WifiContainerQueueType>(queueId)});
+                        {item->GetTimestamp(), std::get<WifiContainerQueueType>(queueId)});
         }
     }
 }
@@ -184,7 +180,7 @@
         {
             SetPriority(ac,
                         queueId,
-                        {item->GetExpiryTime(), std::get<WifiContainerQueueType>(queueId)});
+                        {item->GetTimestamp(), std::get<WifiContainerQueueType>(queueId)});
         }
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/frame-exchange-manager.cc ns-3.39/src/wifi/model/frame-exchange-manager.cc
--- ns-3.38/src/wifi/model/frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/frame-exchange-manager.cc	2023-07-05 14:23:48.109428400 -0700
@@ -19,8 +19,8 @@
 
 #include "frame-exchange-manager.h"
 
-#include "qos-blocked-destinations.h"
 #include "snr-tag.h"
+#include "sta-wifi-mac.h"
 #include "wifi-mac-queue.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-utils.h"
@@ -319,7 +319,7 @@
     if (!mpdu)
     {
         NS_LOG_DEBUG("Queue empty");
-        m_dcf->NotifyChannelReleased(m_linkId);
+        NotifyChannelReleased(m_dcf);
         m_dcf = nullptr;
         return false;
     }
@@ -414,26 +414,50 @@
         m_mpdu->SetInFlight(m_linkId);
     }
 
-    switch (m_txParams.m_protection->method)
+    StartProtection(m_txParams);
+
+    if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
+    {
+        // we are done with frames that do not require acknowledgment
+        m_mpdu = nullptr;
+    }
+}
+
+void
+FrameExchangeManager::StartProtection(const WifiTxParameters& txParams)
+{
+    NS_LOG_FUNCTION(this << &txParams);
+
+    switch (txParams.m_protection->method)
     {
     case WifiProtection::RTS_CTS:
-        SendRts(m_txParams);
+        SendRts(txParams);
         break;
     case WifiProtection::CTS_TO_SELF:
-        SendCtsToSelf(m_txParams);
+        SendCtsToSelf(txParams);
         break;
     case WifiProtection::NONE:
-        SendMpdu();
+        ProtectionCompleted();
         break;
     default:
-        NS_ABORT_MSG("Unknown protection type");
+        NS_ABORT_MSG("Unknown protection type: " << txParams.m_protection.get());
     }
+}
 
-    if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
-    {
-        // we are done with frames that do not require acknowledgment
-        m_mpdu = nullptr;
-    }
+void
+FrameExchangeManager::ProtectionCompleted()
+{
+    NS_LOG_FUNCTION(this);
+    m_protectedStas.merge(m_sentRtsTo);
+    m_sentRtsTo.clear();
+    NS_ASSERT(m_mpdu);
+    SendMpdu();
+}
+
+const std::set<Mac48Address>&
+FrameExchangeManager::GetProtectedStas() const
+{
+    return m_protectedStas;
 }
 
 void
@@ -499,7 +523,39 @@
 {
     NS_LOG_FUNCTION(this << *mpdu << txVector);
 
-    m_phy->Send(Create<WifiPsdu>(mpdu, false), txVector);
+    auto psdu = Create<WifiPsdu>(mpdu, false);
+    FinalizeMacHeader(psdu);
+    m_phy->Send(psdu, txVector);
+}
+
+void
+FrameExchangeManager::FinalizeMacHeader(Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << psdu);
+
+    if (m_mac->GetTypeOfStation() != STA)
+    {
+        return;
+    }
+
+    auto pmMode = StaticCast<StaWifiMac>(m_mac)->GetPmMode(m_linkId);
+
+    for (const auto& mpdu : *PeekPointer(psdu))
+    {
+        switch (pmMode)
+        {
+        case WIFI_PM_ACTIVE:
+        case WIFI_PM_SWITCHING_TO_ACTIVE:
+            mpdu->GetHeader().SetNoPowerManagement();
+            break;
+        case WIFI_PM_POWERSAVE:
+        case WIFI_PM_SWITCHING_TO_PS:
+            mpdu->GetHeader().SetPowerManagement();
+            break;
+        default:
+            NS_ABORT_MSG("Unknown PM mode: " << +pmMode);
+        }
+    }
 }
 
 void
@@ -675,6 +731,8 @@
                   mpdu,
                   rtsCtsProtection->rtsTxVector);
     m_channelAccessManager->NotifyCtsTimeoutStartNow(timeout);
+    NS_ASSERT(m_sentRtsTo.empty());
+    m_sentRtsTo = {receiver};
 
     ForwardMpduDown(mpdu, rtsCtsProtection->rtsTxVector);
 }
@@ -762,7 +820,9 @@
     Time ctsDuration = m_phy->CalculateTxDuration(GetCtsSize(),
                                                   ctsToSelfProtection->ctsTxVector,
                                                   m_phy->GetPhyBand());
-    Simulator::Schedule(ctsDuration + m_phy->GetSifs(), &FrameExchangeManager::SendMpdu, this);
+    Simulator::Schedule(ctsDuration + m_phy->GetSifs(),
+                        &FrameExchangeManager::ProtectionCompleted,
+                        this);
 }
 
 void
@@ -846,7 +906,7 @@
     }
     else
     {
-        m_dcf->NotifyChannelReleased(m_linkId);
+        NotifyChannelReleased(m_dcf);
         m_dcf = nullptr;
     }
 }
@@ -856,11 +916,19 @@
 {
     NS_LOG_FUNCTION(this);
     // A non-QoS station always releases the channel upon a transmission failure
-    m_dcf->NotifyChannelReleased(m_linkId);
+    NotifyChannelReleased(m_dcf);
     m_dcf = nullptr;
 }
 
 void
+FrameExchangeManager::NotifyChannelReleased(Ptr<Txop> txop)
+{
+    NS_LOG_FUNCTION(this << txop);
+    txop->NotifyChannelReleased(m_linkId);
+    m_protectedStas.clear();
+}
+
+void
 FrameExchangeManager::NormalAckTimeout(Ptr<WifiMpdu> mpdu, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << *mpdu << txVector);
@@ -913,6 +981,7 @@
 {
     NS_LOG_FUNCTION(this << *psdu);
 
+    m_sentRtsTo.clear();
     for (const auto& mpdu : *PeekPointer(psdu))
     {
         if (mpdu->IsQueued())
@@ -1237,7 +1306,7 @@
 
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyCtsTimeoutResetNow();
-            Simulator::Schedule(m_phy->GetSifs(), &FrameExchangeManager::SendMpdu, this);
+            Simulator::Schedule(m_phy->GetSifs(), &FrameExchangeManager::ProtectionCompleted, this);
         }
         else if (hdr.IsAck() && m_mpdu && m_txTimer.IsRunning() &&
                  m_txTimer.GetReason() == WifiTxTimer::WAIT_NORMAL_ACK)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/frame-exchange-manager.h ns-3.39/src/wifi/model/frame-exchange-manager.h
--- ns-3.38/src/wifi/model/frame-exchange-manager.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/frame-exchange-manager.h	2023-07-05 14:23:48.109428400 -0700
@@ -241,6 +241,11 @@
     virtual bool VirtualCsMediumIdle() const;
 
     /**
+     * \return the set of stations that have successfully received an RTS in this TXOP.
+     */
+    const std::set<Mac48Address>& GetProtectedStas() const;
+
+    /**
      * Notify that an internal collision has occurred for the given Txop
      *
      * \param txop the Txop for which an internal collision has occurred
@@ -300,6 +305,18 @@
     void SendMpduWithProtection(Ptr<WifiMpdu> mpdu, WifiTxParameters& txParams);
 
     /**
+     * Start the protection mechanism indicated by the given TX parameters
+     *
+     * \param txParams the TX parameters
+     */
+    virtual void StartProtection(const WifiTxParameters& txParams);
+
+    /**
+     * Transmit prepared frame upon successful protection mechanism.
+     */
+    virtual void ProtectionCompleted();
+
+    /**
      * Update the NAV, if needed, based on the Duration/ID of the given <i>psdu</i>.
      *
      * \param psdu the received PSDU
@@ -438,6 +455,13 @@
      */
     virtual uint32_t GetPsduSize(Ptr<const WifiMpdu> mpdu, const WifiTxVector& txVector) const;
 
+    /**
+     * Notify the given Txop that channel has been released.
+     *
+     * \param txop the given Txop
+     */
+    virtual void NotifyChannelReleased(Ptr<Txop> txop);
+
     Ptr<Txop> m_dcf;                                  //!< the DCF/EDCAF that gained channel access
     WifiTxTimer m_txTimer;                            //!< the timer set upon frame transmission
     EventId m_navResetEvent;                          //!< the event to reset the NAV after an RTS
@@ -449,13 +473,23 @@
     Mac48Address m_self;                              //!< the MAC address of this device
     Mac48Address m_bssid;                             //!< BSSID address (Mac48Address)
     Time m_navEnd;                                    //!< NAV expiration time
-    uint8_t m_linkId;                  //!< the ID of the link this object is associated with
+    std::set<Mac48Address> m_sentRtsTo; //!< the STA(s) which we sent an RTS to (waiting for CTS)
+    std::set<Mac48Address> m_protectedStas; //!< STAs that have replied to an RTS in this TXOP
+    uint8_t m_linkId;                       //!< the ID of the link this object is associated with
     uint16_t m_allowedWidth;           //!< the allowed width in MHz for the current transmission
     bool m_promisc;                    //!< Flag if the device is operating in promiscuous mode
     DroppedMpdu m_droppedMpduCallback; //!< the dropped MPDU callback
     AckedMpdu m_ackedMpduCallback;     //!< the acknowledged MPDU callback
 
     /**
+     * Finalize the MAC header of the MPDUs in the given PSDU before transmission. Tasks
+     * performed by this method include setting the Power Management flag in the MAC header.
+     *
+     * \param psdu the given PSDU
+     */
+    virtual void FinalizeMacHeader(Ptr<const WifiPsdu> psdu);
+
+    /**
      * Forward an MPDU down to the PHY layer.
      *
      * \param mpdu the MPDU to forward down
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/constant-obss-pd-algorithm.cc ns-3.39/src/wifi/model/he/constant-obss-pd-algorithm.cc
--- ns-3.38/src/wifi/model/he/constant-obss-pd-algorithm.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/constant-obss-pd-algorithm.cc	2023-07-05 14:23:48.109428400 -0700
@@ -20,10 +20,10 @@
 #include "constant-obss-pd-algorithm.h"
 
 #include "he-configuration.h"
-#include "he-phy.h"
 
 #include "ns3/config.h"
 #include "ns3/double.h"
+#include "ns3/eht-phy.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/sta-wifi-mac.h"
@@ -56,7 +56,13 @@
 void
 ConstantObssPdAlgorithm::ConnectWifiNetDevice(const Ptr<WifiNetDevice> device)
 {
-    Ptr<WifiPhy> phy = device->GetPhy();
+    auto phy = device->GetPhy();
+    if (phy->GetStandard() >= WIFI_STANDARD_80211be)
+    {
+        auto ehtPhy = DynamicCast<EhtPhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_EHT));
+        NS_ASSERT(ehtPhy);
+        ehtPhy->SetEndOfHeSigACallback(MakeCallback(&ConstantObssPdAlgorithm::ReceiveHeSigA, this));
+    }
     auto hePhy = DynamicCast<HePhy>(phy->GetPhyEntity(WIFI_MOD_CLASS_HE));
     NS_ASSERT(hePhy);
     hePhy->SetEndOfHeSigACallback(MakeCallback(&ConstantObssPdAlgorithm::ReceiveHeSigA, this));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/he-capabilities.cc ns-3.39/src/wifi/model/he/he-capabilities.cc
--- ns-3.38/src/wifi/model/he/he-capabilities.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/he-capabilities.cc	2023-07-05 14:23:48.109428400 -0700
@@ -136,6 +136,14 @@
     return IE_EXT_HE_CAPABILITIES;
 }
 
+void
+HeCapabilities::Print(std::ostream& os) const
+{
+    os << "HE Capabilities=" << GetHeMacCapabilitiesInfo1() << "|" << +GetHeMacCapabilitiesInfo2()
+       << "|" << GetHePhyCapabilitiesInfo1() << "|" << GetHePhyCapabilitiesInfo2() << "|"
+       << +GetHePhyCapabilitiesInfo3() << "|" << GetSupportedMcsAndNss();
+}
+
 uint16_t
 HeCapabilities::GetInformationFieldSize() const
 {
@@ -609,16 +617,4 @@
     return std::min<uint32_t>((1UL << (20 + m_maxAmpduLengthExponent)) - 1, 6500631);
 }
 
-std::ostream&
-operator<<(std::ostream& os, const HeCapabilities& heCapabilities)
-{
-    os << heCapabilities.GetHeMacCapabilitiesInfo1() << "|"
-       << +heCapabilities.GetHeMacCapabilitiesInfo2() << "|"
-       << heCapabilities.GetHePhyCapabilitiesInfo1() << "|"
-       << heCapabilities.GetHePhyCapabilitiesInfo2() << "|"
-       << +heCapabilities.GetHePhyCapabilitiesInfo3() << "|"
-       << heCapabilities.GetSupportedMcsAndNss();
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/he-capabilities.h ns-3.39/src/wifi/model/he/he-capabilities.h
--- ns-3.38/src/wifi/model/he/he-capabilities.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/he-capabilities.h	2023-07-05 14:23:48.109428400 -0700
@@ -38,6 +38,7 @@
     // Implementations of pure virtual methods of WifiInformationElement
     WifiInformationElementId ElementId() const override;
     WifiInformationElementId ElementIdExt() const override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Set the HE MAC Capabilities Info field in the HE Capabilities information element.
@@ -333,14 +334,6 @@
     std::vector<uint8_t> m_rxBwMap;  //!< receive BW map
 };
 
-/**
- * output stream output operator
- * \param os the output stream
- * \param heCapabilities the HE capabilities
- * \returns the output stream
- */
-std::ostream& operator<<(std::ostream& os, const HeCapabilities& heCapabilities);
-
 } // namespace ns3
 
 #endif /* HE_CAPABILITY_H */
